image: registry.gitlab.com/bartk/move:base

#before_script:
#  - tlmgr install xcolor

#  - envir
stages:
  - envirPkg
  - build
  - test
  - coverage
  - deploy

envirPkg:on-scheduleBase:
  image: docker:stable
  before_script:
    - ls
  services:
    - docker:dind
  stage: envirPkg
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/bartk/move:base -f DockerfileBase .
    - docker push registry.gitlab.com/bartk/move:base
  only:
    - schedules

envirPkg:on-scheduleDevel:
  image: docker:stable
  before_script:
    - ls
  services:
    - docker:dind
  stage: envirPkg
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker build -t registry.gitlab.com/bartk/move:devel -f DockerfileDevel .
    - docker push registry.gitlab.com/bartk/move:devel
  only:
    - schedules
#  image: gitlab/dind


build:R:
  stage: build
  script:
    - R -q -e 'sessionInfo()'
    - R CMD build ./
  artifacts:
    expire_in: 20 weeks
    paths:
    - move*.tar.gz

test:R:
  stage: test
  artifacts:
    expire_in: 2 weeks
    when: always
    paths:
    - move.Rcheck/*
    reports:
      junit: junit.xml
  dependencies:
    - build:R
  script:
    - mkdir ~/.R
    - touch ~/.R/Makevars # docker image has some special make vars
    - echo "PKG_FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_FFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CPPFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CXXFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CXX11FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "FFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CXXFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CPPFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CXX11FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - PKG_FILE_NAME=$(ls -1t *.tar.gz | head -n 1)
    - R CMD check "${PKG_FILE_NAME}" 
    - R CMD INSTALL "${PKG_FILE_NAME}"
    - R -q -e 'Sys.setenv(PKG_CXXFLAGS="-Wall -pedantic");Sys.setenv(PKG_CFLAGS="-Wall"); install.packages("'${PKG_FILE_NAME}'")'
    - R -q -e 'devtools::test("./", reporter=JunitReporter$new(file="junit.xml"));sessionInfo()'
    - R -q -e 'stopifnot(length(devtools::check_failures("move.Rcheck/"))==0)'
    
    
test:RotherTz:
  stage: test
  artifacts:
    expire_in: 2 days
    when: always
    paths:
    - move.Rcheck/*
  dependencies:
    - build:R
  script:
    - PKG_FILE_NAME=$(ls -1t *.tar.gz | head -n 1)
    - mkdir ~/.R
    - touch ~/.R/Makevars # docker image has some special make vars
    - echo "PKG_FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_FFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CPPFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CXXFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "PKG_CXX11FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "FFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CXXFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CPPFLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo "CXX11FLAGS = -g -O2 -Wall -pedantic" >> ~/.R/Makevars
    - echo 'Sys.setenv(TZ="EST");message("tz:", Sys.timezone())'> .Rprofile
    - R CMD check "${PKG_FILE_NAME}" --as-cran
    - R CMD INSTALL "${PKG_FILE_NAME}"
    - R -q -e 'Sys.setenv(PKG_CXXFLAGS="-Wall -pedantic");Sys.setenv(PKG_CFLAGS="-Wall"); install.packages("'${PKG_FILE_NAME}'")'
    - R -q -e 'stopifnot(length(devtools::check_failures("move.Rcheck/"))==0)'
  when: manual


coverage:R:
  stage: coverage
  dependencies:
    - build:R
  script:
    - R -q -e "Sys.setenv(NOT_CRAN='true');require(covr); (a<-package_coverage('./')); report(a, file='index.html', browse=F)"
  artifacts:
    paths:
    - lib/
    - index.html

pages:
  stage: deploy
  before_script:
    - ls
  dependencies:
    - coverage:R
  script:
    - R -e 'pkgdown::build_site(devel=F)'
    - mkdir tmp; mv public/* tmp
    - mkdir public/dev
    - mv tmp/* public/dev
    - git checkout `git tag | sort -V | tail -1`
    - R -e 'pkgdown::build_site(devel=F)'
    - mkdir public/covr
    - mv index.html public/covr
    - mv lib/ public/covr
  artifacts:
    paths:
      - public
  only:
    - master

build:Rdevel:
  stage: build
  image: registry.gitlab.com/bartk/move:devel
  script:
    - Rdevel -q -e 'sessionInfo()'
    - Rdevel CMD build ./
  artifacts:
    expire_in: 20 weeks
    paths:
    - move*.tar.gz
  only:
    - master

test:Rdevel:
  stage: test
  image: registry.gitlab.com/bartk/move:devel
  artifacts:
    expire_in: 2 weeks
    when: always
    paths:
    - move.Rcheck/*
    reports:
      junit: junit.xml
  dependencies:
    - build:Rdevel
  script:
    - PKG_FILE_NAME=$(ls -1t *.tar.gz | head -n 1)
    - Rdevel CMD check "${PKG_FILE_NAME}"
    - Rdevel CMD INSTALL "${PKG_FILE_NAME}"
    - Rdevel -q -e 'Sys.setenv(PKG_CXXFLAGS="-Wall -pedantic");Sys.setenv(PKG_CFLAGS="-Wall"); install.packages("'${PKG_FILE_NAME}'")'
    - Rdevel -q -e 'devtools::test("./", reporter=JunitReporter$new(file="junit.xml"));sessionInfo()'
    - Rdevel -q -e 'stopifnot(length(devtools::check_failures("move.Rcheck/"))==0)'
  only:
    - master

test:revDep:
  stage: test
  timeout: 3h
  script:
    - install2.r --error cranlike callr curl desc digest parsedate rappdirs rematch2 withr
    - R -q -e 'devtools::install_github("r-lib/revdepcheck")'
    - R -q -e 'require(revdepcheck); revdep_check();revdep_report_problems()'
  only:
    - master
  dependencies:
    - build:R
  when: manual
  artifacts:
    expire_in: 2 weeks
    when: always
    paths:
    - revdep/

